clear all; close all; clc,

path(pathdef);

addpath('0_data_A1_A2');
% addpath('0_data_A1_A2/210504');
addpath('0_data_A1_A2/220628_Kuh21_2');
addpath('0_data_A1_A2/240725_R1C8_N2v_ErrorBar');

load neededParameterForBenchmarking.mat
index_v1 = 16;
species_engergy = species{2};
v_engergy = str2num(cell2mat(erase(species_engergy(index_v1:index_v1+3),'eV')));
v_engergy = [0 v_engergy'];

%% data from Meas.
% file_withpath = '0_data_A1_A2/210504/Nv_3kV_200ns.csv';
% % import time and relative density from each file
% meas_tn01234 = importfile1(file_withpath);
% vib_meas_Nratio = meas_tn01234(:,3:end);
file_withpath = '0_data_A1_A2/240725_R1C8_N2v_ErrorBar/3kV_200ns/qbranch_population_densities.csv';
% import time and relative density from each file
meas_tTn01234567 = importfile2(file_withpath);
meas_tTn01234567(isnan(meas_tTn01234567))=0;
vib_meas_Nratio = meas_tTn01234567(:,6:13);

[t_Kuh21,ne_Kuh21] = get_n_Te('0_data_A1_A2/220628_Kuh21_2/ne_1_3kv200ns.csv');


%% data from Sim. 
% sp = SimParameters('InputFolder/InputFile.txt');
spp = SimParametersP('InputFolder/InputFile_pulsed.txt');


% -----------------------------1_0
% pulse-on
t_loki_on = str2num(spp.Params.pulse.t_lokiCall);
pon1_multi = [];
pon_multi = [];
for i=1:length(t_loki_on)-1
    filestr_on1 = sprintf('Output_gamma0/N2Pulsed/Pulseon_1_%d.mat',i);
    filestr_on = sprintf('Output_gamma0/N2Pulsed/Pulseon_6_%d.mat',i);
    pon1_temp = load(filestr_on1);
    pon_temp = load(filestr_on);
    pon1_temp.sol(:,1) = pon1_temp.sol(:,1)+t_loki_on(i);
    pon_temp.sol(:,1) = pon_temp.sol(:,1)+t_loki_on(i);
    pon1_multi =[pon1_multi; pon1_temp.sol];
    pon_multi =[pon_multi; pon_temp.sol];
end

% pulse-off
filestr_off1 = sprintf('Output_gamma0/N2Pulsed/Pulseoff_1.mat',i);
filestr_off = sprintf('Output_gamma0/N2Pulsed/Pulseoff_6.mat',i);
poff1_temp = load(filestr_off1);
poff_temp = load(filestr_off);
poff1_multi = poff1_temp.sol;
poff_multi = poff_temp.sol;

% vib
pon.sol = pon_multi;
poff.sol = poff_multi;

timea_sim = pon.sol(:,1);
timeb_sim = poff.sol(:,1)+pon.sol(end,1);
vib_dist_sim_t_1_0 = [timea_sim; timeb_sim];

e_sol_index = spp.SpeciesIndex('e')+1;
N2_sol_index = spp.SpeciesIndex('N2')+1;
N2v1_sol_index = spp.SpeciesIndex('N2v1')+1;
% % (1) N2(v=0) density
% vib_dist_sim_n = [pon_multi(:,N2_sol_index); poff_multi(:,N2_sol_index)];
% % (2) sum all the species densities as N2 gas density.
% vib_dist_sim_n = [sum(pon_multi(:,2:end-1),2); sum(poff_multi(:,2:end-1),2)];
% (3) sum (N2(v=0)+N2(v=1-57)) as N2 gas density
vib_dist_sim_n = [pon_multi(:,N2_sol_index); poff_multi(:,N2_sol_index)] +...
    [sum(pon_multi(:,N2v1_sol_index:end-1),2); sum(poff_multi(:,N2v1_sol_index:end-1),2)];
vib_dist_sim_n = [vib_dist_sim_n [pon.sol(:,N2v1_sol_index); poff.sol(:,N2v1_sol_index)]];
for i=1:3
    vib_dist_sim_n = [vib_dist_sim_n [pon.sol(:,N2v1_sol_index+i); poff.sol(:,N2v1_sol_index+i)]];
end
vib_sim_Nratio_1_0 = vib_dist_sim_n(:,2:end)./vib_dist_sim_n(:,1);
ne_1_0 = [pon_multi(:,e_sol_index); poff_multi(:,e_sol_index)]; 


% -----------------------------ref
% pulse-on
t_loki_on = str2num(spp.Params.pulse.t_lokiCall);
pon1_multi = [];
pon_multi = [];
for i=1:length(t_loki_on)-1
    filestr_on1 = sprintf('Output_gamma3e_3/N2Pulsed/Pulseon_1_%d.mat',i);
    filestr_on = sprintf('Output_gamma3e_3/N2Pulsed/Pulseon_6_%d.mat',i);
    pon1_temp = load(filestr_on1);
    pon_temp = load(filestr_on);
    pon1_temp.sol(:,1) = pon1_temp.sol(:,1)+t_loki_on(i);
    pon_temp.sol(:,1) = pon_temp.sol(:,1)+t_loki_on(i);
    pon1_multi =[pon1_multi; pon1_temp.sol];
    pon_multi =[pon_multi; pon_temp.sol];
end

% pulse-off
filestr_off1 = sprintf('Output_gamma3e_3/N2Pulsed/Pulseoff_1.mat',i);
filestr_off = sprintf('Output_gamma3e_3/N2Pulsed/Pulseoff_6.mat',i);
poff1_temp = load(filestr_off1);
poff_temp = load(filestr_off);
poff1_multi = poff1_temp.sol;
poff_multi = poff_temp.sol;

% vib
pon.sol = pon_multi;
poff.sol = poff_multi;

timea_sim = pon.sol(:,1);
timeb_sim = poff.sol(:,1)+pon.sol(end,1);
vib_dist_sim_t_ref = [timea_sim; timeb_sim];

e_sol_index = spp.SpeciesIndex('e')+1;
N2_sol_index = spp.SpeciesIndex('N2')+1;
N2v1_sol_index = spp.SpeciesIndex('N2v1')+1;
% vib_dist_sim_n = [pon.sol(:,N2_sol_index); poff.sol(:,N2_sol_index)];
vib_dist_sim_n = [pon_multi(:,N2_sol_index); poff_multi(:,N2_sol_index)] +...
    [sum(pon_multi(:,N2v1_sol_index:end-1),2); sum(poff_multi(:,N2v1_sol_index:end-1),2)];
vib_dist_sim_n = [vib_dist_sim_n [pon.sol(:,N2v1_sol_index); poff.sol(:,N2v1_sol_index)]];
for i=1:3
    vib_dist_sim_n = [vib_dist_sim_n [pon.sol(:,N2v1_sol_index+i); poff.sol(:,N2v1_sol_index+i)]];
end
vib_sim_Nratio_ref = vib_dist_sim_n(:,2:end)./vib_dist_sim_n(:,1);
ne_ref = [pon_multi(:,e_sol_index); poff_multi(:,e_sol_index)]; 


% -----------------------------4_1
% pulse-on
t_loki_on = str2num(spp.Params.pulse.t_lokiCall);
pon1_multi = [];
pon_multi = [];
for i=1:length(t_loki_on)-1
    filestr_on1 = sprintf('Output_gamma1/N2Pulsed/Pulseon_1_%d.mat',i);
    filestr_on = sprintf('Output_gamma1/N2Pulsed/Pulseon_6_%d.mat',i);
    pon1_temp = load(filestr_on1);
    pon_temp = load(filestr_on);
    pon1_temp.sol(:,1) = pon1_temp.sol(:,1)+t_loki_on(i);
    pon_temp.sol(:,1) = pon_temp.sol(:,1)+t_loki_on(i);
    pon1_multi =[pon1_multi; pon1_temp.sol];
    pon_multi =[pon_multi; pon_temp.sol];
end

% pulse-off
filestr_off1 = sprintf('Output_gamma1/N2Pulsed/Pulseoff_1.mat',i);
filestr_off = sprintf('Output_gamma1/N2Pulsed/Pulseoff_6.mat',i);
poff1_temp = load(filestr_off1);
poff_temp = load(filestr_off);
poff1_multi = poff1_temp.sol;
poff_multi = poff_temp.sol;

% vib
pon.sol = pon_multi;
poff.sol = poff_multi;

timea_sim = pon.sol(:,1);
timeb_sim = poff.sol(:,1)+pon.sol(end,1);
vib_dist_sim_t_4_1 = [timea_sim; timeb_sim];

e_sol_index = spp.SpeciesIndex('e')+1;
N2_sol_index = spp.SpeciesIndex('N2')+1;
N2v1_sol_index = spp.SpeciesIndex('N2v1')+1;
% vib_dist_sim_n = [pon.sol(:,N2_sol_index); poff.sol(:,N2_sol_index)];
vib_dist_sim_n = [pon_multi(:,N2_sol_index); poff_multi(:,N2_sol_index)] +...
    [sum(pon_multi(:,N2v1_sol_index:end-1),2); sum(poff_multi(:,N2v1_sol_index:end-1),2)];
vib_dist_sim_n = [vib_dist_sim_n [pon.sol(:,N2v1_sol_index); poff.sol(:,N2v1_sol_index)]];
for i=1:3
    vib_dist_sim_n = [vib_dist_sim_n [pon.sol(:,N2v1_sol_index+i); poff.sol(:,N2v1_sol_index+i)]];
end
vib_sim_Nratio_4_1 = vib_dist_sim_n(:,2:end)./vib_dist_sim_n(:,1);
ne_4_1 = [pon_multi(:,e_sol_index); poff_multi(:,e_sol_index)]; 


%% power
t_power = importpower(spp.Params.pulse.lut);

% figure(1)
% species = 2;
% 
% % together
% poff1_multi(:,1) = poff1_multi(:,1) + pon1_multi(end,1);
% den1_multi = [pon1_multi;poff1_multi];
% poff_multi(:,1) = poff_multi(:,1) + pon_multi(end,1);
% den_multi = [pon_multi;poff_multi];
% 
% plot(den_multi(:,1)*1e9,den_multi(:,species),'r')
% 
% xlabel('Time (ns)')
% xlim([1e1 1e6])
% xticks([1e1 logspace(2,6,5)])
% set(gca, 'XScale', 'log')
figure(1)

yyaxis left
m1=plot(t_Kuh21(:,1)+50,ne_Kuh21(:,1)./1e19,'o','Color','k','MarkerSize',5);
set(m1, 'markerfacecolor', get(m1, 'color'));
hold on
plot(vib_dist_sim_t_1_0(:,1)*1e9,ne_1_0(:,1)./1e19,'k-','Linewidth',2)
hold on
plot(vib_dist_sim_t_ref(:,1)*1e9,ne_ref(:,1)./1e19,'b--','Linewidth',2)
hold on
plot(vib_dist_sim_t_4_1(:,1)*1e9,ne_4_1(:,1)./1e19,'r:','Linewidth',2)
hold on

xlabel('Time (ns)')
ylabel('Electron density (10^{19} m^{-3})')
xlim([0 500])
xticks([0:100:500])
ylim([-0.2 12])
yticks([0:2:12])
set(gca, 'XScale')
set(gca, 'YScale')

set(gca,'FontSize',15)

yyaxis right
set(gca, 'YScale')
plot(t_power(:,1).*1e9,t_power(:,2)./1e3,'-.','color',[0 0.5 0],'Linewidth',2);
ylim([-0.5 23])
yticks([0 10 20])
ylabel('Absorbed power (kW)')
ax = gca;
ax.YAxis(1).Color = 'k';
ax.YAxis(2).Color = [0 0.5 0];

lgd = legend('Kuhfeld {\itet al}','Sim. (\gamma = 0)','Sim. (\gamma = 3x10^{-3})','Sim. (\gamma = 1)','power',...
    'Orientation','horizontal','NumColumns',1,'Location','NorthEast');
lgd.FontSize = 13;
text(-0.17,1.02,'(a)','Units','normalized','Color','k','FontSize',15)
text(0.2,0.7,'50-250 ns:    power-on phase','Units','normalized','Color','k','FontSize',12)
text(0.2,0.65,'50-75   ns:    peak-power phase','Units','normalized','Color','k','FontSize',12)
text(0.2,0.6,'75-250 ns:    plateau-power phase','Units','normalized','Color','k','FontSize',12)
set(gcf,'position',[100,100,500,700])

% saveas(figure(1),'/home/he/Pictures/paper_2/wall_gamma0_gamma1_Kuh21_3kv200ns_ne.jpg');



%% plot

figure(2)
subplot(4,1,1)
yyaxis left
m1=errorbar(meas_tTn01234567(:,1).*1e9,vib_meas_Nratio(:,7).*100,vib_meas_Nratio(:,8).*100,'o','Color','k','MarkerSize',5)
set(m1, 'markerfacecolor', get(m1, 'color'));
hold on
plot(vib_dist_sim_t_1_0(:,1)*1e9,vib_sim_Nratio_1_0(:,4).*100,'k-','Linewidth',2)
hold on
plot(vib_dist_sim_t_ref(:,1)*1e9,vib_sim_Nratio_ref(:,4).*100,'b--','Linewidth',2)
hold on
plot(vib_dist_sim_t_4_1(:,1)*1e9,vib_sim_Nratio_4_1(:,4).*100,'r:','Linewidth',2)
hold on
% xlabel('Time (ns)')
% ylabel('{N_{2}(v)/N_{gas}} (%)')
xlim([1e1 1e6])
% xticks([1e1 logspace(2,6,5)])
% set(gca,'xtick',[])
set(gca,'xticklabel',[])
ylim([-0.1 1.1])
yticks([0 0.5 1])
set(gca, 'XScale', 'log')

set(gca, 'YScale')

set(gca,'FontSize',15)

yyaxis right
set(gca, 'YScale')
plot(t_power(:,1).*1e9,t_power(:,2)./1e3,'-.','color',[0 0.5 0],'Linewidth',2);
ylim([-1 23])
yticks([0 10 20])
% ylabel('Absorbed power (kW)')
ax = gca;
ax.YAxis(1).Color = 'k';
ax.YAxis(2).Color = [0 0.5 0];

% legend('Meas.','Sim. A2','Sim. A9')
% text(0.90,0.85,'(c)','Units','normalized','Color','k','FontSize',15)
text(0.05,0.85,'v=4','Units','normalized','Color','k','FontSize',15)
text(-0.17,1.1,'(a)','Units','normalized','Color','k','FontSize',15)

subplot(4,1,2)
yyaxis left
m1=errorbar(meas_tTn01234567(:,1).*1e9,vib_meas_Nratio(:,5).*100,vib_meas_Nratio(:,6).*100,'o','Color','k','MarkerSize',5)
set(m1, 'markerfacecolor', get(m1, 'color'));
hold on
plot(vib_dist_sim_t_1_0(:,1)*1e9,vib_sim_Nratio_1_0(:,3).*100,'k-','Linewidth',2)
hold on
plot(vib_dist_sim_t_ref(:,1)*1e9,vib_sim_Nratio_ref(:,3).*100,'b--','Linewidth',2)
hold on
plot(vib_dist_sim_t_4_1(:,1)*1e9,vib_sim_Nratio_4_1(:,3).*100,'r:','Linewidth',2)
hold on
% xlabel('Time (ns)')
% ylabel('{N_{2}(v)/N_{gas}} (%)')
xlim([1e1 1e6])
% xticks([1e1 logspace(2,6,5)])
% set(gca,'xtick',[])
set(gca,'xticklabel',[])
ylim([-0.2 2.2])
yticks([0 1 2])
set(gca, 'XScale', 'log')
set(gca, 'YScale')

set(gca,'FontSize',15)

yyaxis right
set(gca, 'YScale')
plot(t_power(:,1).*1e9,t_power(:,2)./1e3,'-.','color',[0 0.5 0],'Linewidth',2);
ylim([-1 23])
yticks([0 10 20])
% ylabel('Absorbed power (kW)')
ax = gca;
ax.YAxis(1).Color = 'k';
ax.YAxis(2).Color = [0 0.5 0];

text(0.05,0.85,'v=3','Units','normalized','Color','k','FontSize',15)

subplot(4,1,3)
yyaxis left
m1=errorbar(meas_tTn01234567(:,1).*1e9,vib_meas_Nratio(:,3).*100,vib_meas_Nratio(:,4).*100,'o','Color','k','MarkerSize',5)
set(m1, 'markerfacecolor', get(m1, 'color'));
hold on
plot(vib_dist_sim_t_1_0(:,1)*1e9,vib_sim_Nratio_1_0(:,2).*100,'k-','Linewidth',2)
hold on
plot(vib_dist_sim_t_ref(:,1)*1e9,vib_sim_Nratio_ref(:,2).*100,'b--','Linewidth',2)
hold on
plot(vib_dist_sim_t_4_1(:,1)*1e9,vib_sim_Nratio_4_1(:,2).*100,'r:','Linewidth',2)
hold on
% xlabel('Time (ns)')
% ylabel('{N_{2}(v)/N_{gas}} (%)')
xlim([1e1 1e6])
% xticks([1e1 logspace(2,6,5)])
% set(gca,'xtick',[])
set(gca,'xticklabel',[])
% ylim([-0.5 5.5])
% yticks([0 2.5 5])
ylim([-0.6 6.6])
yticks([0 3 6])
set(gca, 'XScale', 'log')
set(gca, 'YScale')

set(gca,'FontSize',15)

yyaxis right
set(gca, 'YScale')
plot(t_power(:,1).*1e9,t_power(:,2)./1e3,'-.','color',[0 0.5 0],'Linewidth',2);
ylim([-1 23])
yticks([0 10 20])
% ylabel('Absorbed power (kW)')
ax = gca;
ax.YAxis(1).Color = 'k';
ax.YAxis(2).Color = [0 0.5 0];

text(0.05,0.85,'v=2','Units','normalized','Color','k','FontSize',15)

subplot(4,1,4)
yyaxis left
m1=errorbar(meas_tTn01234567(:,1).*1e9,vib_meas_Nratio(:,1).*100,vib_meas_Nratio(:,2).*100,'o','Color','k','MarkerSize',5)
set(m1, 'markerfacecolor', get(m1, 'color'));
hold on
plot(vib_dist_sim_t_1_0(:,1)*1e9,vib_sim_Nratio_1_0(:,1).*100,'k-','Linewidth',2)
hold on
plot(vib_dist_sim_t_ref(:,1)*1e9,vib_sim_Nratio_ref(:,1).*100,'b--','Linewidth',2)
hold on
plot(vib_dist_sim_t_4_1(:,1)*1e9,vib_sim_Nratio_4_1(:,1).*100,'r:','Linewidth',2)
hold on
xlabel('Time (ns)')
ylabel('{n_{N_2(v)} / n_{gas}} (%)')
xlim([1e1 1e6])
xticks([1e1 logspace(2,6,5)])
% ylim([-2 22])
% yticks([0 10 20])
ylim([-2.4 26.4])
yticks([0 12 24])
set(gca, 'XScale', 'log')
set(gca, 'YScale')

set(gca,'FontSize',15)

yyaxis right
set(gca, 'YScale')
plot(t_power(:,1).*1e9,t_power(:,2)./1e3,'-.','color',[0 0.5 0],'Linewidth',2);
ylim([-1 23])
yticks([0 10 20])
ylabel('Absorbed power (kW)')
ax = gca;
ax.YAxis(1).Color = 'k';
ax.YAxis(2).Color = [0 0.5 0];

text(0.05,0.85,'v=1','Units','normalized','Color','k','FontSize',15)

% ax = axes('Position', [left bottom width height])
set(subplot(4,1,1), 'Position', [0.13 0.72 0.76 0.2])
set(subplot(4,1,2), 'Position', [0.13 0.52 0.76 0.2])
set(subplot(4,1,3), 'Position', [0.13 0.32 0.76 0.2])
set(subplot(4,1,4), 'Position', [0.13 0.12 0.76 0.2])
% set(subplot(4,1,1), 'Position', [0.13 0.695 0.76 0.195])
% set(subplot(4,1,2), 'Position', [0.13 0.50 0.76 0.195])
% set(subplot(4,1,3), 'Position', [0.13 0.305 0.76 0.195])
% set(subplot(4,1,4), 'Position', [0.13 0.11  0.76 0.195])

lgd = legend('Meas.','Sim. (\gamma = 0)','Sim. (\gamma = 3x10^{-3})','Sim. (\gamma = 1)','power',...
    'Orientation','horizontal','NumColumns',3,'Location','NorthEast','position',[0.14 0.925 0.74 0.05]);
% lgd = legend('Meas.','Sim. (sfHO)','Sim. (SSH)','Sim. (FHO)','power',...
%     'Orientation','horizontal','NumColumns',5,'Location','NorthEast','position',[0.14 0.88 0.74 0.05]);
lgd.FontSize = 11;
% set(gcf,'position',[100,100,700,700])
set(gcf,'position',[100,100,600,900])

% saveas(figure(2),'/home/he/Pictures/paper_2/wall_gamma0_gamma1_Kuh21_3kv200ns.jpg');

saveas(figure(2),'9a_wall_gamma0_gamma1_Kuh21_3kv200ns.jpg');
exportgraphics(figure(2),'9a_wall_gamma0_gamma1_Kuh21_3kv200ns.pdf','BackgroundColor','none','ContentType','vector');